/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2020 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blockentity.machine.tier1;

import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import reborncore.api.IToolDrop;
import reborncore.common.powerSystem.PowerAcceptorBlockEntity;
import reborncore.common.util.WorldUtils;
import techreborn.blocks.machine.tier1.BlockPlayerDetector;
import techreborn.blocks.machine.tier1.BlockPlayerDetector.PlayerDetectorType;
import techreborn.config.TechRebornConfig;
import techreborn.init.TRContent;
import techreborn.init.TRBlockEntities;

public class PlayerDectectorBlockEntity extends PowerAcceptorBlockEntity implements IToolDrop {


	public String owenerUdid = "";
	boolean redstone = false;

	public PlayerDectectorBlockEntity() {
		super(TRBlockEntities.PLAYER_DETECTOR);
	}
	
	public boolean isProvidingPower() {
		return redstone;
	}

	// TilePowerAcceptor
	@Override
	public void method_16896() {
		super.method_16896();
		if (!field_11863.field_9236 && field_11863.method_8510() % 20 == 0) {
			boolean lastRedstone = redstone;
			redstone = false;
			if (canUseEnergy(TechRebornConfig.playerDetectorEuPerTick)) {
				for(class_1657 player : field_11863.method_18456()){
					if (player.method_5739(player) <= 256.0D) {
						PlayerDetectorType type = field_11863.method_8320(field_11867).method_11654(BlockPlayerDetector.TYPE);
						if (type == PlayerDetectorType.ALL) {// ALL
							redstone = true;
						} else if (type == PlayerDetectorType.OTHERS) {// Others
							if (!owenerUdid.isEmpty() && !owenerUdid.equals(player.method_5667().toString())) {
								redstone = true;
							}
						} else {// You
							if (!owenerUdid.isEmpty() && owenerUdid.equals(player.method_5667().toString())) {
								redstone = true;
							}
						}
					}
				}
				useEnergy(TechRebornConfig.playerDetectorEuPerTick);
			}
			if (lastRedstone != redstone) {
				WorldUtils.updateBlock(field_11863, field_11867);
				field_11863.method_8452(field_11867, field_11863.method_8320(field_11867).method_11614());
			}
		}
	}
	
	@Override
	public double getBaseMaxPower() {
		return TechRebornConfig.playerDetectorMaxEnergy;
	}

	@Override
	public boolean canAcceptEnergy(class_2350 direction) {
		return true;
	}

	@Override
	public boolean canProvideEnergy(class_2350 direction) {
		return false;
	}

	@Override
	public double getBaseMaxOutput() {
		return 0;
	}

	@Override
	public double getBaseMaxInput() {
		return TechRebornConfig.playerDetectorMaxInput;
	}

	@Override
	public void method_11014(class_2487 tag) {
		super.method_11014(tag);
		owenerUdid = tag.method_10558("ownerID");
	}

	@Override
	public class_2487 method_11007(class_2487 tag) {
		super.method_11007(tag);
		tag.method_10582("ownerID", owenerUdid);
		return tag;
	}

	// IToolDrop
	@Override
	public class_1799 getToolDrop(class_1657 p0) {
		return TRContent.Machine.PLAYER_DETECTOR.getStack();
	}
}
