/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2020 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.client.render;

import net.fabricmc.fabric.api.renderer.v1.render.RenderContext;
import net.minecraft.class_1058;
import net.minecraft.class_1059;
import net.minecraft.class_1091;
import net.minecraft.class_1092;
import net.minecraft.class_1799;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import techreborn.TechReborn;

import java.util.Random;
import java.util.function.Supplier;

public class DynamicCellBakedModel extends BaseDynamicFluidBakedModel {

	private static final class_1091 CELL_BASE = new class_1091(new class_2960(TechReborn.MOD_ID, "cell_base"), "inventory");
	private static final class_1091 CELL_BACKGROUND = new class_1091(new class_2960(TechReborn.MOD_ID, "cell_background"), "inventory");
	private static final class_1091 CELL_FLUID = new class_1091(new class_2960(TechReborn.MOD_ID, "cell_fluid"), "inventory");
	private static final class_1091 CELL_GLASS = new class_1091(new class_2960(TechReborn.MOD_ID, "cell_glass"), "inventory");

	@Override
	public void emitItemQuads(class_1799 stack, Supplier<Random> randomSupplier, RenderContext context) {
		super.emitItemQuads(stack, randomSupplier, context);

		class_1092 bakedModelManager = class_310.method_1551().method_1554();
		context.fallbackConsumer().accept(bakedModelManager.method_4742(CELL_GLASS));
	}

	@Override
	public class_1058 method_4711() {
		return class_310.method_1551()
				.method_1549(class_1059.field_5275)
				.apply(new class_2960("techreborn:item/cell_base"));
	}

	@Override
	public class_1091 getBaseModel() {
		return CELL_BASE;
	}

	@Override
	public class_1091 getBackgroundModel() {
		return CELL_BACKGROUND;
	}

	@Override
	public class_1091 getFluidModel() {
		return CELL_FLUID;
	}
}
