/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2020 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.client.render.entitys;

import techreborn.entities.EntityNukePrimed;
import techreborn.init.TRContent;

import javax.annotation.Nullable;
import net.minecraft.class_1059;
import net.minecraft.class_1160;
import net.minecraft.class_2960;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_897;
import net.minecraft.class_898;
import net.minecraft.class_957;

/**
 * Created by Mark on 13/03/2016.
 */
public class RenderNukePrimed extends class_897<EntityNukePrimed> {

	public RenderNukePrimed(class_898 renderManager) {
		super(renderManager);
		this.field_4673 = 0.5F;
	}

	@Nullable
	@Override
	public class_2960 getTexture(EntityNukePrimed entityNukePrimed) {
		return class_1059.field_5275;
	}

	@Override
	public void render(EntityNukePrimed entity, float f, float g, class_4587 matrixStack, class_4597 vertexConsumerProvider, int i) {
		matrixStack.method_22903();
		matrixStack.method_22904(0.0D, 0.5D, 0.0D);
		if ((float)entity.method_6968() - g + 1.0F < 10.0F) {
			float h = 1.0F - ((float)entity.method_6968() - g + 1.0F) / 10.0F;
			h = class_3532.method_15363(h, 0.0F, 1.0F);
			h *= h;
			h *= h;
			float j = 1.0F + h * 0.3F;
			matrixStack.method_22905(j, j, j);
		}

		matrixStack.method_22907(class_1160.field_20705.method_23214(-90.0F));
		matrixStack.method_22904(-0.5D, -0.5D, 0.5D);
		class_957.method_23190(TRContent.NUKE.method_9564(), matrixStack, vertexConsumerProvider, i, entity.method_6968() / 5 % 2 == 0);
		matrixStack.method_22909();
		super.method_3936(entity, f, g, matrixStack, vertexConsumerProvider, i);
	}
}
