/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2020 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.events;

import techreborn.TechReborn;
import techreborn.init.TRContent;
import techreborn.utils.RecipeUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;
import net.minecraft.class_1856;
import net.minecraft.class_1860;
import net.minecraft.class_3222;
import net.minecraft.class_3956;

public class TRRecipeHandler {


	public static void unlockTRRecipes(class_3222 playerMP) {
		List<class_1860<?>> recipeList = new ArrayList<>();
		for (class_1860<?> recipe : RecipeUtils.getRecipes(playerMP.field_6002, class_3956.field_17545)) {
			if (isRecipeValid(recipe)) {
				recipeList.add(recipe);
			}
		}
		playerMP.method_7254(recipeList);
	}

	private static boolean isRecipeValid(class_1860<?> recipe) {
		if (recipe.method_8114() == null) {
			return false;
		}
		if (!recipe.method_8114().method_12836().equals(TechReborn.MOD_ID)) {
			return false;
		}
		return !recipe.method_8117().stream().anyMatch((Predicate<class_1856>) ingredient -> ingredient.method_8093(TRContent.Parts.UU_MATTER.getStack()));
	}

}
