/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2020 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.utils;

import team.reborn.energy.Energy;

import java.util.Random;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1890;
import net.minecraft.class_1893;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2680;

/**
 * @author drcrazy
 *
 */

public class ToolsUtil {
    public static void breakBlock(class_1799 tool, class_1937 world, class_2338 pos, class_1309 entityLiving, int cost) {
        if (!(entityLiving instanceof class_1657)) {
            return;
        }
        class_2680 blockState = world.method_8320(pos);
        if (blockState.method_11579(world, pos) == -1.0F) {
            return;
        }
		Random rand = new Random();
		if (rand.nextInt(class_1890.method_8225(class_1893.field_9119, tool) + 1) == 0) {
			if (!Energy.of(tool).use(cost)) {
				return;
			}
		}
        blockState.method_11614().method_9556(world, (class_1657) entityLiving, pos, blockState, world.method_8321(pos), tool);
        world.method_8501(pos, class_2246.field_10124.method_9564());
        world.method_8544(pos);
    }
}
